<?php
include "MyPDO.php";
include "VueEntites.php";
include "EntiteEntites.php";
include "vardsn.php";

function getDebutHTML(): string {
    return "<!DOCTYPE html>
<html>
  <head>
    <meta charset="."'utf-8'".">
    <meta http-equiv="."'X-UA-Compatible'"." content="."'IE=edge'".">
    <meta name="."'viewport'"." content="."width=device-width, initial-scale=1".">
    <title>CRUD Application </title>
    <link rel="."'stylesheet'"." href="."'https://cdn.jsdelivr.net/npm/bulma@0.8.0/css/bulma.min.css'".">
    <script defer src="."'https://use.fontawesome.com/releases/v5.3.1/js/all.js'"."></script>
  </head>
  <body>

    <section class="."'hero is-medium is-dark'".">
      &nbsp;
          <div class="."'columns is-vcentered is-centered'".">
            <div class="."'column is-narrow has-text-centered'".">
              <img
              src="."'europe.png'"."
              />
            </div>
          </div>
          &nbsp;

    </section>
      <section>
    <center>
    <nav class='navbar is-dark is-fixed-top' role='navigation' aria-label='main navigation'>
  <div class='navbar-brand'>
 
   

    <a role=button' class='navbar-burger burger' aria-label='menu' aria-expanded='false' data-target='navbarBasicExample'>
      <span aria-hidden='true'></span>
      <span aria-hidden='true'></span>
      <span aria-hidden='true'></span>
    </a>
  </div>

  <div id='navbarBasicExample' class='navbar-menu'>
    <div class='navbar-start'>
    <a class='navbar-item' href='index.php'>
        Accueil
      </a>
      <a class='navbar-item' href='CRUDentites.php'>
        Entités
      </a>

      <a class='navbar-item' href='CRUDpays.php'>
        Pays
      </a>
      <a class='navbar-item'  href='CRUDLangue.php'>
        Langue 
      </a>
      <a class='navbar-item'  href='CRUDlangue_pays.php'>
        Langue Pays 
      </a>
      <a class='navbar-item'  href='CRUDorganisation.php'>
      Organisation
    </a>
   
      </div>
        </div>
        </nav>

    </section>
    &nbsp;
     <center><h1 class='title is-1'>Liste des Entites</h1></center>
";
}

function getFinHTML(): string {
    return "
 <footer class="."'footer has-text-centered has-background-grey'".">
         <div class="."'columns '".">
           <div class="."'column is-3  '".">
          
             <strong class="."'title is-4'".">
             <p>Designed by : AOUIDA Sawsen & BENOSMAN Adnane & SASOUAD Lamia & YOUNSI Tayssir</p> 
             </strong>
                <p>
               <strong class="."'title is-4'".">
                 <a >© Université du Havre 2021 </a>
               </strong>
             </p>
             <p>
             </p>
           </div>
             <div class="."'column'"."></div>
          <div class="."'column is-2 has-text-left'".">
          
          
          </div>
        </div>

    </footer>
    <script type="."'text/javascript'"." src="."'lib/main.js'"."></script>
<!-- contenu -->
</body>
</html>
";
}

session_start();

// initialisation de la connexion via l'instance de MyPDO
try {
    $myPDOentites = new MyPDO($_ENV['sgbd'], $_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'],"entites");
    echo "connexion établie";
    // ecrire une exception
} catch (PDOException $e) {
    print "Erreur !: " . $e->getMessage() . "<br/>";
    die();
}

// initialisation du générateur de vues HTML
$vue = new EntiteEurope\VueEntites();

// initialisation des chaînes à afficher
$contenu = "";
$message = "";

// traitement des différentes actions possibles

if (isset($_GET['action']))
    switch ($_GET['action']) {
        case 'read':
            $entites= $myPDOentites->get('id_entites', $_GET['id_entites']);
            $contenu .= $vue->getHTML4Entites($entites);
            $_SESSION['etat'] = 'lecture';
            break;
        case 'create':
            $nbEntites = $myPDOentites->count();
            $contenu .= $vue->getFormulaireEntites(array('id_entites' => array ('type'=>'number', 'default'=> $nbEntites+1), 'nom_entites' => 'text', 'description' => 'text','date_creation'=>'date','siege'=>'text'));
            $_SESSION['etat'] = 'création';
            break;
        case 'update':
            $entites = $myPDOentites->get('id_entites',$_GET['id_entites']);
            $contenu .= $vue->getFormulaireEntites(array('id_entites'=>array('type'=>'number','default'=>$entites->getIdEntites()),
                'nom_entites'=>array('type'=>'text','default'=>$entites->getNomEntites()),
                'description'=>array('type'=>'text','default'=>$entites->getDescrip()),
                'date_creation' =>array('type'=>'date','default'=>$entites->getDateCreation()),
                'siege' =>array('type'=>'text','default'=>$entites->getSiege())));


            $_SESSION['etat'] = 'modification';
            break;
        case 'delete':
            $myPDOentites->delete(array('id_entites'=>$_GET['id_entites']));
            $_SESSION['etat'] = 'suppression';
            break;
        default:
            $message .= "<p>Action ".$_GET['action']." non implémentée.</p>\n";
    }

else
    if (isset($_SESSION['etat']))
        switch($_SESSION['etat']) {
            case 'création':
                $myPDOentites->insert(array('id_entites'=>$_GET['id_entites'], 'nom_entites'=>$_GET['nom_entites'], 'description'=>$_GET['description'],'date_creation'=>$_GET['date_creation'],'siege'=>$_GET['siege']));
                $_SESSION['etat'] = 'créé';
                break;
            case 'modification':
                $myPDOentites->update('id_entites', array('id_entites'=>$_GET['id_entites'], 'nom_entites'=>$_GET['nom_entites'], 'description'=>$_GET['description'],'date_creation'=>$_GET['date_creation'],'siege'=>$_GET['siege']));
                $_SESSION['etat'] = 'modifié';
                break;
            case 'suppression':
                $_SESSION['etat']= 'supprimé';
                break;
            case 'créé':
            case 'modifié':
            case 'supprimé':
            default:
                $_SESSION['etat'] = 'neutre';
        }


// affichage du nombre total d entites:
$nbEntites = $myPDOentites->getCountValue();
$message .= "<center><p>La table Entites contient ".$nbEntites." Entites.</p></center>\n";

// sélection/modification/suppression/ d'un EntiteEntites

$contenu .=
    "
 <div class='columns'>
   <div class='colum is-1'>
    <div class='column'>
   <div class='container'>
  <div class='notification'>
  <div class='columns'><div class='column is-1 '></div><div class='column'><form action='?' method='GET'>
        <table class='table is-striped is-narrow is-hoverable is-fullwidth'>
            <tr><td>
            <select class='select is-rounded is-fullwidth is-black is-size-6'  name='action'>
            <h1 class='title is-3'><strong></strong></h1>
             <option value='read'>Lire</option>
            <option value='update'>Modifier</option>
            <option value='delete'>Supprimer</option>
</select></td>
 
<td><input class='button is-fullwidth is-black ' type='submit' name='envoi' value='Go' /></td></tr>
</table></form></div><div class='column is-1' ></div></div>\n
</select>

</form>
   </div>
  
&nbsp;
<div class='tabs  is-boxed  is-centered'>
</div>
</div>

\n";



// création d'un nouvelle entites
// Attention suppose que le nombre d entites présent correspond au dernier identifiant attribué...
$contenu .="
<div class='columns'><div class='column is-1 '>
</div><div class='column '><a href='?action=create'>
<input class='button is-fullwidth  is-black ' type='submit' name='envoi' value='Creer une nouvelle entiteEntites' /></div>
<div class='column is-1'></div></div>  ";
$contenu .= $nbEntites+1;
$contenu .= "</a> </p>";

// récupération et affichage de la liste des entites avec liens vers édition/suppresion

$lesEntites = $myPDOentites->getAll();
$contenu .= $vue->getAllEntites($lesEntites);
$contenu.="";
// Production de la page HTML
echo getDebutHTML();
echo $message;
echo $contenu;
echo getFinHTML();