<?php

namespace EntiteEurope;

class EntitePays {
    const TABLENAME = 'EntitePays';
    static $COLNAMES = array('id_pays','nom_pays','capital','population','monnaie');
    static $COLTYPES = array('number', 'text', 'text', 'number', 'text');

    static $COLTYPES4UPDATE = array(array('type' => 'hidden', 'default' => ''), 'text', 'text', 'number', 'text');
    static $PrimaryKey = array('id_pays');  // tableau pour une éventuelle clé composite
    static $AUTOID = TRUE; // booléen indiquant si le renseignement de la clé est automatisé



    protected $id_pays;
    protected $nom_pays;
    protected $capital;
    protected $population;
    protected $monnaie;


    /**
     * @return int
     */
    public function getIdPays() : int {
        return $this->id_pays;
    }

    /**
     * @param int $id_pays
     * @return EntiteOrganisation
     */
    public function setIdPays(int $id_pays) : EntiteOrganisation {
        $this->id_pays = $id_pays;
    }

    /**
     * @return string
     */
    public function getNomPays() : string {
        return $this->nom_pays;
    }

    /**
     * @param string $nom_pays
     * @return EntiteOrganisation
     */
    public function setNomPays($nom_pays) : EntiteOrganisation {
        $this->nom_pays = $nom_pays;

    }
    /**
     * @return string
     */
    public function getCapital() : string {
        return $this->capital;
    }

    /**
     * @param string $capital
     * @return EntiteOrganisation
     */
    public function setCapital($capital) : EntiteOrganisation {
        $this->capital = $capital;
    }

    /**
     * @return string
     */
    public function getMonnaie() : string {
        return $this->monnaie;
    }

    /**
     * @param string $monnaie
     * @return EntiteOrganisation
     */
    public function setMonnaie($monnaie) : EntiteOrganisation {
        $this->monnaie = $monnaie;
    }
    public function getPopulation() : int {
        return $this->population;
    }


    /**
     * @return string
     */

    public function __toString() : string
    {
        return " (".$this->id_pays.", ".$this->nom_pays.",".$this->capital.",".$this->population.",".$this->monnaie.")";

    }
}

