<?php

namespace EntiteEurope;

/**
 * Class VueLangue
 */
class VueLangue
{
    public function getHTML4Langue(EntiteLangue $Langue): string
    {
        $ch = "<table border='1'>
        <tr><th>id_langue</th><th>langue_off</th></tr><tr>\n";
        $ch .= "<tr><td>" . $Langue->getIdLangue() . "</td>\n";
        $ch .= "<td>" . $Langue->getLangueOff() . "</td>\n";

        $ch.= "</tr></table>\n";
        return $ch;
    }

    /**
     * production d'une string contenant un formulaire HTML
     * destiné à saisir une nouvelle langue ou à modifier une langue existante
     * @param array $assoc
     * @return string
     */

    public function getFormulaireLangue(array $assoc): string
    {
        $ch = "<form action='".$_SERVER['PHP_SELF']."' method='GET'>\n";
        foreach ($assoc as $col => $val) {
            if (is_array($val)) {
                $ch .= "$col : <input name='$col' type='".$val['type']
                    ."' value='".$val['default']."' />\n";
            }
            else
                $ch .= "$col : <input type='$val' name='$col' />\n";
        }
        $ch .= "<input type='submit' name='Valider' value='Sauver'/>\n";


        return $ch."</form>\n";
    }

    /**
     * production d'une string contenant une liste HTML représentant un ensemble de langue
     * et permettant de les modifier ou de les supprimer grace à un lien hypertexte
     * @param EntiteLangue $tabLangue un tableau d'instances d'EntiteLangue
     * @return string
     */
    public function getAllLangue(array $tabLangue): string
    {
        $ch = "<div class='columns  is-vcentered'><div class='column is-1 is-hidden-mobile '></div><div class='column'> 
<table class="."'table is-bordered is-striped is-narrow is-hoverable is-fullwidth'"." border='1'>
       <tr><th>ID Langue </th><th>Langue Officielle</th><tr>\n";
        foreach ($tabLangue as $Langue) {
            $ch.="<tr>";
            if ($Langue instanceof EntiteLangue) {
                $ch .= "<td>".$Langue->getIdLangue()." </a></td>";
                $ch .= "<td>".$Langue->getLangueOff()." </a></td>";

                $ch .= "<td><a href='?action=update&id_langue=".$Langue->getIdLangue()."'>Modifier</a></td> ";
                $ch .= "<td><a href='?action=delete&id_langue=".$Langue->getIdLangue()."'>Supprimer</a> </td>";

            }
            $ch."</tr>\n";
        }
        return $ch."</table></div><div class='column is-1 is-hidden-mobile '></div></div>\n";
    }
}
?>