<?php


namespace EntiteEurope;
use EntiteEurope\EntitePays;

/**
 * Class VuePays
 * @package EntiteEurope
 */
class VuePays
{

    /**
     * production d'une string contenant un tableau HTML représentant un pays
     * @param EntiteEurope $pays
     * @return string
     */
    public function getHTML4Pays(EntitePays $pays): string
    {
        $ch = "<table border='2'>

        <tr><th>id_pays</th><th>nom_pays</th><th>capital</th><th>population</th><th>monnaie</th></tr><tr>\n";
        $ch .= "<tr><td>" . $pays->getIdPays() . "</td>\n";
        $ch .= "<td>" . $pays->getNomPays() . "</td>\n";
        $ch .= "<td>" . $pays->getCapital() . "</td>\n";
        $ch .= "<td>" . $pays->getPopulation() . "</td>\n";
        $ch .= "<td>" . $pays->getMonnaie() . "</td>\n";
        $ch.= "</tr></table>\n";
        return $ch;
    }

    /**
     * production d'une string contenant un formulaire HTML
     * destiné à saisir un nouveau pays ou à modifier un EntitePays existant
     * @param array $assoc
     * @return string
     */

    public function getFormulairePays(array $assoc): string
    {
        $ch = "<form action='".$_SERVER['PHP_SELF']."' method='GET'>\n";
        foreach ($assoc as $col => $val) {
            if (is_array($val)) {
                $ch .= "$col : <input name='$col' type='".$val['type']
                    ."' value='".$val['default']."' />\n";
            }
            else
                $ch .= "$col : <input type='$val' name='$col' />\n";
        }
        $ch .= "<input type='submit' name='Valider' value='Enregistrer'/>\n";


        return $ch."</form>\n";
    }

    /**
     * production d'une string contenant une liste HTML représentant un ensemble de pays
     * et permettant de les modifier ou de les supprimer grace à un lien hypertexte
     * @param \EntiteEuroper $tabPays un tableau d'instances de EntitePays
     * @return string
     */
    public function getAllPays(array $tabPays): string
    {
        $ch = "<div class='columns  is-vcentered'><div class='column is-1 is-hidden-mobile '></div><div class='column'> 
<table class="."'table is-bordered is-striped is-narrow is-hoverable is-fullwidth'"." border='1'>
       <tr><th>ID pays </th><th>Nom Pays</th><th>Capital</th><th>Population</th><th>Monnaie</th></tr><tr>\n";
        foreach ($tabPays as $pays) {
            $ch .="<tr>";
            if ($pays instanceof EntitePays) {
                $ch .= "<td>".$pays->getIdPays()." </a></td>";
                $ch .= "<td >" .$pays->getNomPays()."</a> </td>";
                $ch .= "<td>".$pays->getCapital()." </a></td>";
                $ch .= "<td>".$pays->getPopulation()."</a></td> ";
                $ch .= "<td>".$pays->getMonnaie()."</a> </td>";
                $ch .= "<td><a href='?action=update&id_pays=".$pays->getIdPays()."'>Modifier</a> </td>";
                $ch .= "<td><a href='?action=delete&id_pays=".$pays->getIdPays()."'>Supprimer</a> </td>";
            }
            $ch."</tr>\n";
        }

        return $ch."</table></div><div class='column is-1 is-hidden-mobile '></div></div>\n";
    }


}